unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, Grids;

type
  TMainForm = class(TForm)
    TopPanel: TPanel;
    LNumNodes: TLabel;
    BRecompPositions: TButton;
    SENumNodes: TSpinEdit;
    SGMatrix: TStringGrid;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SENumNodesExit(Sender: TObject);
    procedure SGMatrixSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure BRecompPositionsClick(Sender: TObject);
  private
    NumNodes : integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormResize(Sender: TObject);
begin
  if Width < 454 then
    Width := 454;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  NumNodes := 0;
  SENumNodesExit(Self);
end;

procedure TMainForm.SENumNodesExit(Sender: TObject);
var nn, r, c : integer;
begin
  nn := SENumNodes.Value;
  SGMatrix.ColCount := nn + 1;
  SGMatrix.RowCount := nn + 1;
  if SENUmNodes.Value > NumNodes then
  begin
    // labels - just redraw all
    for r := NumNodes+1 to nn do
      SGMatrix.Cells[0,r]:='R'+IntToStr(r);
    for c := NumNodes+1 to nn do
      SGMatrix.Cells[c,0]:='C'+IntToStr(c);
    // fill lower block
    for r := NumNodes+1 to nn do
      for c := 1 to nn do
        SGMatrix.Cells[c,r]:='0';
    // fill upper-right block
    for c := NumNodes+1 to nn do
      for r := 1 to NumNodes do
        SGMatrix.Cells[c,r]:='0';
  end;
  NumNodes := SENUmNodes.Value;
end;

procedure TMainForm.SGMatrixSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  v : integer;
begin
  if Length(SGMatrix.Cells[ACol,ARow]) = 0 then
    Exit;
  try
    v := StrToInt(SGMatrix.Cells[ACol,ARow]);
  except
    on EConvertError do
    begin
      v := 1;
    end;
  end;
  if ACol = ARow then
    v := 0
  else
    if v <> 0 then
      v := 1;
  SGMatrix.Cells[ACol,ARow] := IntToStr(v);
  SGMatrix.Cells[ARow,ACol] := IntToStr(v);
  // FormPaint(Self);
end;

procedure TMainForm.BRecompPositionsClick(Sender: TObject);
begin
  // TODO
  // FormPaint(Self);
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  // TODO
end;

end.
